gtkmm: Gdk::FrameClock Class Reference

gtkmm 3.24.11

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gdk::FrameClock Class Reference

Frame clock syncs painting to a window or display. More...

`#include <gdkmm/frameclock.h>`

Inheritance diagram for Gdk::FrameClock:
[legend]

## Public Member Functions
| FrameClock (FrameClock && src) noexcept
FrameClock & | operator= (FrameClock && src) noexcept
| ~FrameClock () noexcept override
GdkFrameClock * | gobj ()
| Provides access to the underlying C GObject.
const GdkFrameClock * | gobj () const
| Provides access to the underlying C GObject.
GdkFrameClock * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
gint64 | get_frame_time () const
| Gets the time that should currently be used for animations.
void | request_phase (FrameClockPhase phase)
| Asks the frame clock to run a particular phase.
void | begin_updating ()
| Starts updates for an animation.
void | end_updating ()
| Stops updates for an animation.
gint64 | get_frame_counter () const
| A Gdk::FrameClock maintains a 64-bit counter that increments for each frame drawn.
gint64 | get_history_start () const
| Gdk::FrameClock internally keeps a history of Gdk::FrameTimings objects for recent frames that can be retrieved with get_timings().
Glib::RefPtr< FrameTimings > | get_timings (gint64 frame_counter)
| Retrieves a Gdk::FrameTimings object holding timing information for the current frame or a recent frame.
Glib::RefPtr< const FrameTimings > | get_timings (gint64 frame_counter) const
| Retrieves a Gdk::FrameTimings object holding timing information for the current frame or a recent frame.
Glib::RefPtr< FrameTimings > | get_current_timings ()
| Gets the frame timings for the current frame.
Glib::RefPtr< const FrameTimings > | get_current_timings () const
| Gets the frame timings for the current frame.
void | get_refresh_info (gint64 base_time, gint64 & refresh_interval_return, gint64 & presentation_time_return) const
| Using the frame history stored in the frame clock, finds the last known presentation time and refresh interval, and assuming that presentation times are separated by the refresh interval, predicts a presentation time that is a multiple of the refresh interval after the last presentation time, and later than base_time.
Glib::SignalProxy< void > | signal_update ()
Glib::SignalProxy< void > | signal_layout ()
Glib::SignalProxy< void > | signal_paint ()
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::FrameClock > | wrap (GdkFrameClock * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

Frame clock syncs painting to a window or display.

A Gdk::FrameClock tells the application when to update and repaint a window. This may be synced to the vertical refresh rate of the monitor, for example. Even when the frame clock uses a simple timer rather than a hardware-based vertical sync, the frame clock helps because it ensures everything paints at the same time (reducing the total number of frames). The frame clock can also automatically stop painting when it knows the frames will not be visible, or scale back animation framerates.

Gdk::FrameClock is designed to be compatible with an OpenGL-based implementation or with mozRequestAnimationFrame in Firefox, for example.

A frame clock is idle until someone requests a frame with request_phase(). At some later point that makes sense for the synchronization being implemented, the clock will process a frame and emit signals for each phase that has been requested. (See the signals of the Gdk::FrameClock class for documentation of the phases. Gdk::FRAME_CLOCK_PHASE_UPDATE and the signal_update() signal are most interesting for application writers, and are used to update the animations, using the frame time given by get_frame_time().

The frame time is reported in microseconds and generally in the same timescale as g_get_monotonic_time(), however, it is not the same as g_get_monotonic_time(). The frame time does not advance during the time a frame is being painted, and outside of a frame, an attempt is made so that all calls to get_frame_time() that are called at a “similar” time get the same value. This means that if different animations are timed by looking at the difference in time between an initial value from get_frame_time() and the value inside the signal_update() signal of the clock, they will stay exactly synchronized.

Since gtkmm 3.24

## Constructor & Destructor Documentation

## ◆ FrameClock()

Gdk::FrameClock::FrameClock | ( | FrameClock && | src | ) |
| noexcept

## ◆ ~FrameClock()

Gdk::FrameClock::~FrameClock | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ begin_updating()

void Gdk::FrameClock::begin_updating | ( |  | ) |

Starts updates for an animation.

Until a matching call to end_updating() is made, the frame clock will continually request a new frame with the Gdk::FRAME_CLOCK_PHASE_UPDATE phase. This function may be called multiple times and frames will be requested until end_updating() is called the same number of times.

Since gtkmm 3.8

## ◆ end_updating()

void Gdk::FrameClock::end_updating | ( |  | ) |

Stops updates for an animation.

See the documentation for begin_updating().

Since gtkmm 3.8

## ◆ get_current_timings() [1/2]

Glib::RefPtr< FrameTimings > Gdk::FrameClock::get_current_timings | ( |  | ) |

Gets the frame timings for the current frame.

Since gtkmm 3.8

Returns
  The Gdk::FrameTimings for the frame currently being processed, or even no frame is being processed, for the previous frame. Before any frames have been processed, returns nullptr.

## ◆ get_current_timings() [2/2]

Glib::RefPtr< const FrameTimings > Gdk::FrameClock::get_current_timings | ( |  | ) | const

Gets the frame timings for the current frame.

Since gtkmm 3.8

Returns
  The Gdk::FrameTimings for the frame currently being processed, or even no frame is being processed, for the previous frame. Before any frames have been processed, returns nullptr.

## ◆ get_frame_counter()

gint64 Gdk::FrameClock::get_frame_counter | ( |  | ) | const

A Gdk::FrameClock maintains a 64-bit counter that increments for each frame drawn.

Since gtkmm 3.8

Returns
  Inside frame processing, the value of the frame counter for the current frame. Outside of frame processing, the frame counter for the last frame.

## ◆ get_frame_time()

gint64 Gdk::FrameClock::get_frame_time | ( |  | ) | const

Gets the time that should currently be used for animations.

Inside the processing of a frame, it’s the time used to compute the animation position of everything in a frame. Outside of a frame, it's the time of the conceptual “previous frame,” which may be either the actual previous frame time, or if that’s too old, an updated time.

Since gtkmm 3.8

Returns
  A timestamp in microseconds, in the timescale of of Glib::get_monotonic_time().

## ◆ get_history_start()

gint64 Gdk::FrameClock::get_history_start | ( |  | ) | const

Gdk::FrameClock internally keeps a history of Gdk::FrameTimings objects for recent frames that can be retrieved with get_timings().

The set of stored frames is the set from the counter values given by get_history_start() and get_frame_counter(), inclusive.

Since gtkmm 3.8

Returns
  The frame counter value for the oldest frame that is available in the internal frame history of the Gdk::FrameClock.

## ◆ get_refresh_info()

void Gdk::FrameClock::get_refresh_info | ( | gint64 | base_time,
|  | gint64 & | refresh_interval_return,
|  | gint64 & | presentation_time_return ) const

Using the frame history stored in the frame clock, finds the last known presentation time and refresh interval, and assuming that presentation times are separated by the refresh interval, predicts a presentation time that is a multiple of the refresh interval after the last presentation time, and later than base_time.

Since gtkmm 3.8

Parameters

  base_time | Base time for determining a presentaton time.
  refresh_interval_return | A location to store the determined refresh interval, or nullptr. A default refresh interval of 1/60th of a second will be stored if no history is present.
  presentation_time_return | A location to store the next candidate presentation time after the given base time. 0 will be will be stored if no history is present.

## ◆ get_timings() [1/2]

Glib::RefPtr< FrameTimings > Gdk::FrameClock::get_timings | ( | gint64 | frame_counter | ) |

Retrieves a Gdk::FrameTimings object holding timing information for the current frame or a recent frame.

The Gdk::FrameTimings object may not yet be complete: see Gdk::FrameTimings::get_complete().

Since gtkmm 3.8

Parameters

  frame_counter | The frame counter value identifying the frame to be received.

Returns
  The Gdk::FrameTimings object for the specified frame, or nullptr if it is not available. See get_history_start().

## ◆ get_timings() [2/2]

Glib::RefPtr< const FrameTimings > Gdk::FrameClock::get_timings | ( | gint64 | frame_counter | ) | const

Retrieves a Gdk::FrameTimings object holding timing information for the current frame or a recent frame.

The Gdk::FrameTimings object may not yet be complete: see Gdk::FrameTimings::get_complete().

Since gtkmm 3.8

Parameters

  frame_counter | The frame counter value identifying the frame to be received.

Returns
  The Gdk::FrameTimings object for the specified frame, or nullptr if it is not available. See get_history_start().

## ◆ get_type()

GType Gdk::FrameClock::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GdkFrameClock * Gdk::FrameClock::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkFrameClock * Gdk::FrameClock::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkFrameClock * Gdk::FrameClock::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FrameClock & Gdk::FrameClock::operator= | ( | FrameClock && | src | ) |
| noexcept

## ◆ request_phase()

void Gdk::FrameClock::request_phase | ( | FrameClockPhase | phase | ) |

Asks the frame clock to run a particular phase.

The signal corresponding the requested phase will be emitted the next time the frame clock processes. Multiple calls to request_phase() will be combined together and only one frame processed. If you are displaying animated content and want to continually request the Gdk::FRAME_CLOCK_PHASE_UPDATE phase for a period of time, you should use begin_updating() instead, since this allows GTK+ to adjust system parameters to get maximally smooth animations.

Since gtkmm 3.8

Parameters

  phase | The phase that is requested.

## ◆ signal_layout()

Glib::SignalProxy< void > Gdk::FrameClock::signal_layout | ( |  | ) |

Slot Prototype:
  void on_my_layout()

Flags: Run Last

This signal is emitted as the second step of toolkit and application processing of the frame. Any work to update sizes and positions of application elements should be performed. GTK+ normally handles this internally.

## ◆ signal_paint()

Glib::SignalProxy< void > Gdk::FrameClock::signal_paint | ( |  | ) |

Slot Prototype:
  void on_my_paint()

Flags: Run Last

This signal is emitted as the third step of toolkit and application processing of the frame. The frame is repainted. GDK normally handles this internally and produces expose events, which are turned into GTK+ Gtk::Widget::signal_draw() signals.

## ◆ signal_update()

Glib::SignalProxy< void > Gdk::FrameClock::signal_update | ( |  | ) |

Slot Prototype:
  void on_my_update()

Flags: Run Last

This signal is emitted as the first step of toolkit and application processing of the frame. Animations should be updated using Gdk::FrameClock::get_frame_time(). Applications can connect directly to this signal, or use gtk_widget_add_tick_callback() as a more convenient interface.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::FrameClock > wrap | ( | GdkFrameClock * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.